# License Agreement for Ionic Resources

Please read the following terms and conditions (the “Agreement”) carefully and completely. This Agreement grants a license to the Ionic Security Inc. (“Ionic”) resources accompanying or associated with this Agreement (“Ionic Resources”) which can be used to interact with the Ionic data security and access control platform and related key management servers (“Platform”).  The Ionic Resources comprise Ionic applications, plug-in components, end point components, software development kits (“SDKs”) and any associated tools, libraries, code samples, and toolkits (collectively, the “Software”; Software provided by Ionic in source code format is the “Source Code”) and associated documentation, if any (“Software Documentation”).  The Ionic Resources expressly exclude any documentation for Ionic API’s which are subject to the separate Documentation User Rights.  Ionic Resources not including any Source Code are the “Restricted Ionic Resources”.   

IF YOU ARE ENTERING INTO THIS AGREEMENT ON BEHALF OF A COMPANY, GOVERNMENT AGENCY, ASSOCIATION OR OTHER LEGAL ENTITY (IN WHICH CASE THE TERMS "YOU" OR "YOUR" SHALL REFER TO SUCH ENTITY AND ITS AFFILIATES), YOU HEREBY REPRESENT AND WARRANT THAT YOU HAVE THE POWER AND AUTHORITY TO ENTER INTO THIS AGREEMENT ON SUCH ENTITY’S BEHALF AND TO BIND SUCH ENTITY AND ITS AFFILIATES HERETO.   

**1.    LICENSE; RESTRICTIONS.**  
1.1   Subject to the terms and conditions of this Agreement, Ionic grants to you a non-exclusive, worldwide (except as restricted herein), non-transferable, non-sublicensable, revocable right and license to (i) make derivative works of any Software provided by Ionic in source code format (“Derivative Works”; the Derivative Works and Ionic Resources cumulatively, the “Resources”), (ii) reproduce as reasonably necessary, install and use the Software and Derivative Works in a non-production environment to test the Software and Derivative Works, (iii) redistribute Source Code in its original source code format on the condition that it is redistributed under this Agreement and a copy of this Agreement is included with each copy of the Source Code and (iv) reproduce as reasonably necessary and use the Software Documentation to support the rights granted in 1.1(i) and (ii).  For clarity, you are not licensed to redistribute any Restricted Ionic Resources or distribute any Derivative Works.  

1.2 If you have been granted the authority to access and use the Platform pursuant to one or more agreements entered into between Ionic and the company, government agency, association or other entity you represent (the “Master Agreement”) then subject to the terms and conditions of this Agreement, Ionic grants to you a non-exclusive, worldwide (except as restricted herein), non-transferable, non-sublicensable, revocable right and license (i) to install and use the object code version of the Software and Derivative Works to interconnect with the Platform and exchange information for your internal business purposes pursuant to the terms and conditions of the Master Agreement during the term of the Master Agreement and (ii) to reproduce as reasonably necessary and use the Software Documentation to support the rights granted in 1.2(i).  

1.3 The licenses set forth in Sections 1.1 and 1.2 also include the right for you to allow affiliates and contractors to access and use the Resources solely to assist you in performing activities within the scope of the rights granted in Section 1.1 and 1.2 for your benefit.  You are responsible for the acts of your affiliates and contractors as if such acts were taken by you.  

1.4    You agree that you will not (and will not permit any third party to) directly or indirectly: (i) use, reproduce or distribute the Resources in any manner inconsistent with the license grants set forth in this Agreement; (ii) decompile, disassemble, reverse engineer or otherwise attempt to reconstruct or discover any source code, algorithms or formulae of any Software that is not Source Code; (iii) use or allow others to use or commercially exploit the Resources to or for the benefit of any third party; (iv) remove any product identification, copyright or other proprietary notice from the Resources; or (v) otherwise engage in any activity that interferes with, disrupts, damages, or accesses in an unauthorized manner the Platform, or any servers, networks, data or other properties of Ionic.  

**2.    REPRESENTATIONS & WARRANTIES**  
2.1   You acknowledge that the Resources contain cryptographic features and may be subject to United States laws governing import, export, distribution and use, including the Export Administration Act of 1979, as amended, any successor legislation, and the Export Administration Regulations issued by the Department of Commerce, International Trade Administration, and Bureau of Export Administration (collectively, the “EAR”). You agree to comply in all respects with the export and re-export restrictions applicable to the Resources and otherwise comply with the EAR or other U.S. laws and regulations in effect from time to time. You will not export or re-export the Resources, directly or indirectly, to: (1) any countries that are subject to U.S. export restrictions (currently including, but not necessarily limited to, Cuba, Iran, North Korea, Sudan, and Syria); or (2) any end user who (i) you know or have reason to know will utilize them in the design, development or production of nuclear, chemical or biological weapons, or rocket systems, space launch vehicles, or sounding rockets, or unmanned air vehicle systems, or (ii) is designated on the U.S. Treasury Department list of Specially Designated Nationals (“Denied Persons List”) or the U.S. Commerce Department's Table of Deny Orders or who has been otherwise prohibited from participating in U.S. export transactions by any federal agency of the U.S. government ((2)(i) and (ii) collectively, a “Denied Person”). You also represent that you are not a Denied Person and consent to Ionic checking you against the Denied Persons List prior to accepting this Agreement or granting you access to the Ionic Resources and from time to time as may be required by applicable law.  

2.2  If you are or any affiliate of yours is the U.S. Federal Government, Ionic provides the Ionic Resources solely in accordance with the term of this Section 2.2. Government technical data and software rights related to the Ionic Resources include only those rights customarily provided to the public as defined in this Agreement. This customary license is provided in accordance with FAR 12.211 (Technical Data) and FAR 12.212 (Software) and, for Department of Defense transactions, DFAR 252.227-7015 (Technical Data – Commercial Items) and DFAR 227.7202-3 (Rights in Commercial Computer Software or Computer Software Documentation). If a government agency has a need for rights not conveyed under these terms, it must negotiate with Ionic directly to determine if there are acceptable terms for transferring such rights, and a mutually acceptable written addendum specifically conveying such rights must be included in any applicable agreements.  

**3.  MODIFICATIONS.**  
You acknowledge and agree that Ionic may modify this Agreement by making a revised version available at http://dev.ionic.com. Your continued access to and use of the Ionic Resources after the revised version is available at http://dev.ionic.com shall constitute your binding acceptance of such modifications.  

**4.  OWNERSHIP; IP RIGHTS.**  
4.1 As between you and Ionic, Ionic owns exclusively and will retain ownership of all right, title, and interest in and to the Ionic Resources, and you will own the Derivative Works to the extent comprising changes and modifications to the Software made by or for you. Subject to the limited rights and licenses expressly provided in this Agreement, nothing herein shall be deemed to convey, transfer or assign to you or any of your affiliates any intellectual property rights of Ionic.  

4.2    You understand that Ionic may license certain software packages, libraries or components of the Software under an open source software license. You understand and acknowledge that your use, reproduction and distribution of any such open source components are governed solely by the terms of the applicable open source software license and not this Agreement. If there are any conflicts between the open source software license and this Agreement, the open source license terms control.  

**5.    ACCESS TO PLATFORM; APPLICATION SUPPORT.**  
This Agreement does not entitle you to access the Ionic Platform. Such access is governed by the Master Agreement.

**6.   CONFIDENTIALITY.**  
6.1  The Restricted Ionic Resources and any information developed in exercising rights granted in the Agreement and related to the performance, features, functionality, fees and usability of the Software and the Platform (cumulatively, the “Ionic Information”) is the proprietary and confidential information of Ionic, except as otherwise expressly stated herein or agreed in writing by Ionic. You will maintain the Ionic Information as proprietary and confidential, and will use the same level of care, but no less than a reasonable level of care, to prevent the unauthorized use, dissemination, or publication of the same as you use to protect your own proprietary and confidential information. The obligations of confidentiality required by this paragraph shall extend, for any Ionic Information that constitutes a Trade Secret (as defined below), so long as such information remains a Trade Secret, and for any Ionic Information that does not constitute a Trade Secret, for a period of three (3) years after the termination of this Agreement. As used herein, “Trade Secrets” means information which derives economic value, actual or potential, from not being generally known to, and not being readily ascertainable by proper means by, other persons who can obtain economic value from its disclosure or use, and is the subject of efforts that are reasonable under the circumstances to maintain its secrecy, including, without limitation, the Software specifications and technical documentation, and any underlying ideas, algorithms, or structure, technical or nontechnical data, formulas, patterns, compilations, programs, devices, methods, techniques, drawings, processes, financial data, financial plans, or product plans.  

6.2 Notwithstanding the foregoing, the obligations of confidentiality required by this Section 6 shall not cover information that (a) was already known to you at the time of disclosure by or on behalf of Ionic without an obligation of confidentiality; (b) was or is obtained by the recipient from a third party not under an obligation of confidentiality with respect to such information; (c) is or becomes generally available to the public other than by violation of an agreement; or (d) was or is independently developed by you without use of the Ionic Information.  

**7. DISCLAIMER OF WARRANTIES.**  
THE IONIC RESOURCES ARE PROVIDED ON AN AS IS AND AS AVAILABLE BASIS, WITHOUT ANY WARRANTIES OF ANY KIND. TO THE MAXIMUM EXTENT ALLOWED UNDER APPLICABLE LAW, NEITHER IONIC NOR ITS LICENSORS OR SUBCONTRACTORS MAKES ANY WARRANTY, EXPRESS, IMPLIED OR STATUTORY, REGARDING THE IONIC RESOURCES. IONIC AND ITS LICENSORS AND SUBCONTRACTORS EXPRESSLY EXCLUDE ANY IMPLIED WARRANTY OF NON-INFRINGEMENT, FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABILITY AND ANY OTHER WARRANTY THAT MIGHT ARISE FROM COURSE OF DEALING OR USAGE OF TRADE REGARDING THE IONIC RESOURCES. WITHOUT LIMITING THE GENERALITY OF THE FOREGOING, IONIC DOES NOT REPRESENT OR WARRANT THAT THE RESOURCES WILL OPERATE IN COMBINATION WITH ANY OF YOUR APPLICATIONS OR ANY OTHER HARDWARE, SOFTWARE, SYSTEM OR DATA. THE SOFTWARE AND DERIVATIVE WORKS MAY BE SUBJECT TO LIMITATIONS, DELAYS, AND OTHER PROBLEMS INHERENT IN THE USE OF THE INTERNET AND ELECTRONIC COMMUNICATIONS THAT ARE PROVIDED BY THIRD PARTIES OTHER THAN IONIC OR ITS SUBCONTRACTORS, AND IONIC IS NOT RESPONSIBLE FOR ANY DELAYS, DELIVERY FAILURES, OR OTHER DAMAGES RESULTING FROM SUCH PROBLEMS.  

**8. INDEMNIFICATION.**  
8.1    Ionic will defend (including paying reasonable and actual attorneys’ fees and court costs) you and your respective officers, directors, employees, and agents (“Indemnified Entities”) from and against any third party claim that your use of the Ionic Resources as licensed hereunder and in accordance with any applicable Software Documentation during any time that you were a party to a valid Master Agreement infringes, misappropriates or otherwise violates the intellectual property rights of such third party and will indemnify and hold harmless the Indemnified Entities from any final, non-appealable judgments or settlement expenses resulting from such a claim, provided that you (a) promptly notify Ionic in writing of such claim, (b) permit Ionic to control of the defense and settlement of the claim, and (c) provide Ionic, at its expense, reasonable assistance as required for the defense and settlement of such claim. Ionic will have no liability for any claim to the extent that it results from: (i) any modification to the Software made by a party other than Ionic, if a claim would not have occurred but for such modification; (ii) the combination, operation or use of the Software with any hardware, software, systems or data of any third party, if a claim would not have occurred but for such combination, operation or use; or (iii) your failure to use the latest version of the Software.  

8.2   You will indemnify and hold Ionic, its officers, directors, employees, and agents harmless from and against any and all losses, costs, damages, expenses and liabilities (including reasonable and actual attorneys’ fees and court costs) arising from or related to: (a) your use of the Ionic Resources other than strictly in accordance with any applicable Software Documentation which infringes, misappropriates or otherwise violates any third party intellectual property rights; (b) any breach of an obligation, representation, warranty, covenant or other provision of this Agreement by you or your affiliates or (c) any matter which you have expressly agreed to be responsible pursuant to this Agreement, provided that Ionic promptly notifies you of such claim.  

**9.   LIMITATION OF LIABILITY.**  
9.1  IONIC AND ITS DIRECTORS, OFFICERS, EMPLOYEES AND AGENTS SHALL NOT BE LIABLE FOR ANY CONSEQUENTIAL, INCIDENTAL, INDIRECT, SPECIAL, EXEMPLARY AND/OR PUNITIVE DAMAGES (EXCEPT WITH REGARD TO PUNITIVE DAMAGES WHICH MAY NOT BE EXCLUDABLE IN THE RELEVANT JURISDICTION), INCLUDING DAMAGES FOR LOST PROFITS, LOSS OF DATA, CORRUPTION OF DATA, OR LOSS OF BUSINESS IN CONNECTION WITH THE RESOURCES OR OTHERWISE UNDER THIS AGREEMENT, REGARDLESS OF THE FORM OF THE ACTION OR THE THEORY OF RECOVERY, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.  

9.2 NOTWITHSTANDING ANYTHING TO THE CONTRARY IN THIS AGREEMENT, IN NO EVENT SHALL IONIC, ITS DIRECTORS, OFFICERS, EMPLOYEES, OR AGENTS BE LIABLE TO YOU OR ANY THIRD PARTY IN CONNECTION WITH THE RESOURCES, OR OTHERWISE HEREUNDER FOR AN AMOUNT GREATER THAN ONE HUNDRED U.S. DOLLARS ($100.00). Some jurisdictions do not allow the exclusion of implied warranties or limitation of liability for incidental or consequential damages, which means that some of the above limitations may not apply to you. IN THESE JURISDICTIONS, THE COMPANY'S LIABILITY WILL BE LIMITED TO THE GREATEST EXTENT PERMITTED BY LAW.  

Notwithstanding the foregoing, the limitations of liability set forth in Sections 9.1 and 9.2 (a) shall not limit either party's indemnification obligations as specified in Section 8 and (b) shall not apply to either party's liability resulting from (i) personal injury, death or tangible property damages resulting from the party's gross negligence or willful misconduct or (ii) a breach of your confidentiality obligations set forth in Section 6.   

**10.    TERM AND TERMINATION.**   
This Agreement shall commence on the effective date hereof and will remain in effect until terminated pursuant to this Section 10. Either party may terminate this Agreement at any time for convenience upon notice. Any termination of this Agreement shall also terminate the licenses granted to you hereunder. Upon termination of this Agreement for any reason, you shall cease using, and either return to Ionic, or destroy and remove from all computers, hard drives, networks, and other storage media, all copies of the Ionic Resources. The provisions of this Agreement pertaining to ownership of the Resources, intellectual property, confidential information, disclaimer of warranties, exclusion of damages, indemnity, and miscellaneous issues shall survive any termination of this Agreement for any reason.  

**11.    MISCELLANEOUS.**   
11.1   This Agreement, together with the Master Agreement and any other guidelines, terms of use or policies as Ionic may from time to time adopt and publish, constitutes the entire understanding between you and Ionic with respect to the Ionic Resources, and supersedes all prior and collateral communications, reports, and understandings between you and Ionic in respect thereto; provided, however, that in the event of any conflict between this Agreement and the Master Agreement, the terms of the Master Agreement will control.  

11.2  The parties understand and agree that the mutual promises and covenants of this Agreement are special, unique, and of extraordinary character, and in the event of any default, breach, or threatened breach of this Agreement by you, Ionic shall be entitled, at its sole discretion, to institute proceedings in any court of competent jurisdiction, either at law or in equity, and shall be entitled to any and all such remedies (including any damages, injunctive relief, or combination thereof) as may be available at law or in equity.  

11.3 Except as set forth in Section 3 above, no change, modification, alteration, or addition to, or any waiver of, any provision of this Agreement shall be binding unless in writing and executed by authorized representatives of both you and Ionic. No waiver of any provision of this Agreement shall render unenforceable any other provision of this Agreement.  

11.4    In the event that any provision of this Agreement is held void, voidable, invalid, or inoperative, no other provision of this Agreement shall be affected as a result thereof, and the remaining provisions of this Agreement shall remain in full force and effect.  

11.5   This Agreement shall be governed by and interpreted in accordance with the laws of the State of Georgia, United States of America, without giving effect to any conflicts of laws principles. All disputes arising out of this Agreement will be subject to the exclusive jurisdiction and venue of the state courts located in Fulton County, Georgia and the federal courts located in the Northern District of Georgia, and each Party hereby consents to the personal jurisdiction thereof.  

11.6  All notices to be provided by Ionic to you under this Agreement may be delivered in writing: (i) by nationally recognized overnight delivery service or U.S. Mail to any contact mailing address provided by you; or (ii) by electronic mail to the electronic mail address provided by you. All notices to be provided by you to Ionic hereunder must be delivered in writing by nationally recognized overnight delivery service or U.S. Mail to the following address: Ionic Security Inc., 1170 Peachtree St., NE, Suite 400, Atlanta, GA 30309 USA, Attn: Chief Legal Counsel, or by electronic mail to legal@ionicsecurity.com. All notices shall be deemed to have been given immediately upon delivery by confirmed electronic mail, or if otherwise delivered upon receipt or, if earlier, two (2) business days after being deposited in the mail or with a Courier as permitted above.   


Last updated 04/23/2018